using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Taylor
{
    public partial class Form1 : Form
    {
        private double xM;
        // TODO: besser als Ressourcen einbetten!
        private Bitmap rendeer = new Bitmap(@"..\..\rentier.png");
        private Bitmap santa = new Bitmap(@"..\..\santa.png"); 

        public Form1()
        {
            rendeer.SetResolution(96.0f, 96.0f);
            santa.SetResolution(96.0f, 96.0f);
            InitializeComponent();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

            List<PointF> points = new List<PointF>();
            for (double x = -10; x <= 20.0; x+= 0.1)
            {
                double y = Math.Sin(x);
                points.Add(math2Screen(x, y));
            }
            e.Graphics.DrawLines(Pens.Black, points.ToArray());

            double f = Math.Sin(xM);
            double fPrime = (Math.Sin(xM + 0.001) - Math.Sin(xM - 0.001)) / (2.0 * 0.001);//Math.Cos(xM);
            double fPrime2 = (Math.Sin(xM + 0.001) -2.0*f + Math.Sin(xM - 0.001)) / (0.001 * 0.001);//-Math.Sin(xM);
            double fPrime3 = -Math.Cos(xM);
            double fPrime4 = Math.Sin(xM);

            points.Clear();
            for (double x = -10; x <= 20.0; x += 0.1)
            {
                double y = f + fPrime*(x-xM);
                points.Add(math2Screen(x, y));
            }
            e.Graphics.DrawLines(Pens.Green, points.ToArray());

            // TODO: Polynome effizienter mit Horner-Schema!

            points.Clear();
            for (double x = -10; x <= 20.0; x += 0.1)
            {
                double y = f + fPrime * (x - xM) + fPrime2 * (x - xM) * (x - xM)/2.0;
                points.Add(math2Screen(x, y));
            }
            e.Graphics.DrawLines(Pens.Blue, points.ToArray());

            points.Clear();
            for (double x = -10; x <= 20.0; x += 0.1)
            {
                double y = f + fPrime * (x - xM) + fPrime2 * (x - xM) * (x - xM) / 2.0 + fPrime3 * (x - xM) * (x - xM) * (x - xM) /6.0;
                points.Add(math2Screen(x, y));
            }
            e.Graphics.DrawLines(Pens.Turquoise, points.ToArray());
            points.Clear();
            for (double x = -10; x <= 20.0; x += 0.1)
            {
                double y = f + fPrime * (x - xM) + fPrime2 * (x - xM) * (x - xM) / 2.0 + fPrime3 * (x - xM) * (x - xM) * (x - xM) / 6.0 + fPrime4 * (x - xM) * (x - xM) * (x - xM) * (x - xM) / 24.0;
                points.Add(math2Screen(x, y));
            }
            e.Graphics.DrawLines(Pens.Violet, points.ToArray());

            double yM = Math.Sin(xM);
            PointF p = math2Screen(xM, yM);
            e.Graphics.FillEllipse(Brushes.Red, p.X-4.0f, p.Y-4.0f, 8.0f, 8.0f);

            Matrix oldMatrix = e.Graphics.Transform;
            e.Graphics.TranslateTransform(p.X, p.Y);
            e.Graphics.RotateTransform((float)(180.0 / Math.PI * Math.Atan(fPrime * (ClientSize.Height - 1) / 4.0 / ((ClientSize.Width - 1) / 30.0))));
            e.Graphics.TranslateTransform(-p.X, -p.Y);
            e.Graphics.DrawImage(santa, p.X-santa.Width/2, p.Y-santa.Height);
            e.Graphics.Transform = oldMatrix;

            double xR = xM;
            for (int i = 0; i < 5; i++)
            {
                double fPrimeBefore = fPrime*( (ClientSize.Height - 1) / 4.0) /((ClientSize.Width - 1) / 30.0);
                xR += 1.0/Math.Sqrt(1.0+fPrimeBefore*fPrimeBefore) * rendeer.Width / (double)(ClientSize.Width - 1) * 30.0;
                double yR = Math.Sin(xR);
                p = math2Screen(xR, yR);
                fPrime = Math.Cos(xR);
                oldMatrix = e.Graphics.Transform;
                e.Graphics.TranslateTransform(p.X, p.Y);
                e.Graphics.RotateTransform((float)(180.0 / Math.PI * Math.Atan(fPrime * (ClientSize.Height - 1) / 4.0 / ((ClientSize.Width - 1) / 30.0))));
                e.Graphics.TranslateTransform(-p.X, -p.Y);
                e.Graphics.DrawImage(rendeer, p.X - rendeer.Width / 2, p.Y - rendeer.Height);
                e.Graphics.Transform = oldMatrix;                
            }
        }

        private PointF math2Screen(double x, double y)
        {
            float xS = (float)((ClientSize.Width - 1) / 30.0 * (x + 10.0));
            float yS = (float)((ClientSize.Height - 1) / 4.0 * (y+2.0));
            return new PointF(xS, yS);
        }

        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            Invalidate();
        }

        protected override void OnMouseMove(MouseEventArgs e)
        {
            base.OnMouseMove(e);
            changeX(e.X);
        }

        private void changeX(int x)
        {
            xM = 30.0 * x / (ClientSize.Width - 1) - 10.0;
            Invalidate();
        }
    }
}